package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTLiteral_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTLiteral extends ISLASTExpression  {
	
	/* @generated */
	protected ISLASTLiteral(long ptr) {
		/*** PROTECTED REGION ID(ISLASTLiteral_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTLiteral build(long ptr) {
		return new ISLASTLiteral(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTLiteral_userCode) ENABLED START ***/
	public long getValue() {
		return getValueAsVal().asLong();
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_expr_get_val 
	 * 
	 * @generated
	**/
	public ISLVal getValueAsVal() {
		/*** PROTECTED REGION ID(isl_ast_expr_get_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_ast_expr_get_val(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLASTExpressionVisitor visitor) {
		visitor.visitISLASTLiteral(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTLiteral_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
